

===================== parser output ===============================

let rec f  x = (x + 123)
in 
   let rec g  y = f
   in (print_int ((g 456) 789))

===================== typing output ===============================

let rec f  : (int) -> int x : int = (x + 123)
in 
   let rec g  : (int) -> (int) -> int y : int = f
   in (print_int ((g 456) 789))

===================== knormal output ===============================

let f  : (int) -> intx : int = 
   let Ti5  : int = 123 in
   (x + Ti5)
in 
   let g  : (int) -> (int) -> inty : int = f
   in 
      let Ti4  : int = let Tf2  : (int) -> int = let Ti1  : int = 456 in
      (g Ti1) in
      
      let Ti3  : int = 789 in
      (Tf2 Ti3) in
      EXTERN(print_int Ti4)

===================== alpha output ===============================

let f_6  : (int) -> intx_7 : int = 
   let Ti5_14  : int = 123 in
   (x_7 + Ti5_14)
in 
   let g_8  : (int) -> (int) -> inty_9 : int = f_6
   in 
      let Ti4_10  : int = let Tf2_11  : (int) -> int = let Ti1_13  : int = 456 in
      (g_8 Ti1_13) in
      
      let Ti3_12  : int = 789 in
      (Tf2_11 Ti3_12) in
      EXTERN(print_int Ti4_10)

===================== simplify output ===============================

let f_6  : (int) -> intx_7 : int = 
   let Ti5_14  : int = 123 in
   (x_7 + Ti5_14)
in 
   let g_8  : (int) -> (int) -> inty_9 : int = f_6
   in 
      let Ti1_13  : int = 456 in
      
      let Tf2_11  : (int) -> int = (g_8 Ti1_13) in
      
      let Ti3_12  : int = 789 in
      
      let Ti4_10  : int = (Tf2_11 Ti3_12) in
      EXTERN(print_int Ti4_10)

===================== closure output ===============================
let LABEL(f_6) [] x_7 : int = 
   let Ti5_14  : int = 123 in
   (x_7 + Ti5_14)
in

let LABEL(g_8) [f_6 : (int) -> int] y_9 : int = f_6
in

let closure f_6  : (int) -> int = ( LABEL(f_6); [] )
in 
   let closure g_8  : (int) -> (int) -> int = ( LABEL(g_8); [f_6] )
   in 
      let Ti1_13  : int = 456 in
      
      let Tf2_11  : (int) -> int = APPLY_CLOSURE(g_8 Ti1_13) in
      
      let Ti3_12  : int = 789 in
      
      let Ti4_10  : int = APPLY_CLOSURE(Tf2_11 Ti3_12) in
      APPLY_DIRECT(LABEL(min_caml_print_int) Ti4_10)

===================== virtual  output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(f_6) (arg=(x_7), farg=())

LET(Ti5_14, set(123), 
   ANSWER(add(x_7, Ti5_14)))

LABEL(g_8) (arg=(y_9), farg=())

LET(f_6, ld(%o5, 4), 
   ANSWER(mov(f_6)))
==== Expression =======

LET(f_6, mov(%i1), 
   LET(%i1, add(%i1, 8), 
      LET(l_18, set(LABEL(f_6)), 
         LET(Tu19, st(l_18, f_6, 0), 
            LET(g_8, mov(%i1), 
               LET(%i1, add(%i1, 8), 
                  LET(l_16, set(LABEL(g_8)), 
                     LET(Tu17, st(l_16, g_8, 0), 
                        LET(Tu15, st(f_6, g_8, 4), 
                           LET(Ti1_13, set(456), 
                              LET(Tf2_11, CallClosure(g_8, args=(Ti1_13), farg=()), 
                                 LET(Ti3_12, set(789), 
                                    LET(Ti4_10, CallClosure(Tf2_11, args=(Ti3_12), farg=()), 
                                       ANSWER(CallDirect(LABEL(min_caml_print_int), args=(Ti4_10), farg=())))))))))))))))


=====================  simm13  output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(f_6) (arg=(x_7), farg=())

ANSWER(add(x_7, 123))

LABEL(g_8) (arg=(y_9), farg=())

LET(f_6, ld(%o5, 4), 
   ANSWER(mov(f_6)))
==== Expression =======

LET(f_6, mov(%i1), 
   LET(%i1, add(%i1, 8), 
      LET(l_18, set(LABEL(f_6)), 
         LET(Tu19, st(l_18, f_6, 0), 
            LET(g_8, mov(%i1), 
               LET(%i1, add(%i1, 8), 
                  LET(l_16, set(LABEL(g_8)), 
                     LET(Tu17, st(l_16, g_8, 0), 
                        LET(Tu15, st(f_6, g_8, 4), 
                           LET(Ti1_13, set(456), 
                              LET(Tf2_11, CallClosure(g_8, args=(Ti1_13), farg=()), 
                                 LET(Ti3_12, set(789), 
                                    LET(Ti4_10, CallClosure(Tf2_11, args=(Ti3_12), farg=()), 
                                       ANSWER(CallDirect(LABEL(min_caml_print_int), args=(Ti4_10), farg=())))))))))))))))


===================== RegAlloc output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(f_6) (arg=(%i2), farg=())

ANSWER(add(%i2, 123))

LABEL(g_8) (arg=(%i2), farg=())

LET(%i2, ld(%o5, 4), 
   ANSWER(mov(%i2)))
==== Expression =======

LET(%i2, mov(%i1), 
   LET(%i1, add(%i1, 8), 
      LET(%i3, set(LABEL(f_6)), 
         LET(%g0, st(%i3, %i2, 0), 
            LET(%o5, mov(%i1), 
               LET(%i1, add(%i1, 8), 
                  LET(%i3, set(LABEL(g_8)), 
                     LET(%g0, st(%i3, %o5, 0), 
                        LET(%g0, st(%i2, %o5, 4), 
                           LET(%i2, set(456), 
                              LET(%o5, CallClosure(%o5, args=(%i2), farg=()), 
                                 LET(%i2, set(789), 
                                    LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                       ANSWER(CallDirect(LABEL(min_caml_print_int), args=(%i2), farg=())))))))))))))))


===================== Emit output ===============================
.section	".rodata"
.align	8
.section	".text"
f_6:
	add	%i2, 123, %i2
	retl
	nop
g_8:
	ld	[%o5 + 4], %i2
	retl
	nop
.global	min_caml_start
min_caml_start:
	save	%sp, -112, %sp
	mov	%i1, %i2
	add	%i1, 8, %i1
	set	f_6, %i3
	st	%i3, [%i2 + 0]
	mov	%i1, %o5
	add	%i1, 8, %i1
	set	g_8, %i3
	st	%i3, [%o5 + 0]
	st	%i2, [%o5 + 4]
	set	456, %i2
	st	%o7, [%i0 + 4]
	ld	[%o5 + 0], %o4
	call	%o4
	add	%i0, 8, %i0	! delay slot
	sub	%i0, 8, %i0
	ld	[%i0 + 4], %o7
	mov	%i2, %o5
	set	789, %i2
	st	%o7, [%i0 + 4]
	ld	[%o5 + 0], %o4
	call	%o4
	add	%i0, 8, %i0	! delay slot
	sub	%i0, 8, %i0
	ld	[%i0 + 4], %o7
	st	%o7, [%i0 + 4]
	call	min_caml_print_int
	add	%i0, 8, %i0	! delay slot
	sub	%i0, 8, %i0
	ld	[%i0 + 4], %o7
	ret
	restore
