

===================== parser output ===============================

let x  = 17
in 
   let rec f  y = 
      let rec g  z = ((x + y) + z)
      in g
   in 
      let first  = (f 21)
      in 
         let second  = (f 88)
         in 
            let result  = ((first 99) + (second 44))
            in (print_int result)

===================== typing output ===============================

let x  : int = 17
in 
   let rec f  : (int) -> (int) -> int y : int = 
      let rec g  : (int) -> int z : int = ((x + y) + z)
      in g
   in 
      let first  : (int) -> int = (f 21)
      in 
         let second  : (int) -> int = (f 88)
         in 
            let result  : int = ((first 99) + (second 44))
            in (print_int result)

===================== knormal output ===============================

let x  : int = 17 in

let f  : (int) -> (int) -> inty : int = 
   let g  : (int) -> intz : int = 
      let Ti7  : int = (x + y) in
      (Ti7 + z)
   in g
in 
   let first  : (int) -> int = let Ti1  : int = 21 in
   (f Ti1) in
   
   let second  : (int) -> int = let Ti2  : int = 88 in
   (f Ti2) in
   
   let result  : int = let Ti4  : int = let Ti3  : int = 99 in
   (first Ti3) in
   
   let Ti6  : int = let Ti5  : int = 44 in
   (second Ti5) in
   (Ti4 + Ti6) in
   EXTERN(print_int result)

===================== alpha output ===============================

let x_8  : int = 17 in

let f_9  : (int) -> (int) -> inty_10 : int = 
   let g_20  : (int) -> intz_21 : int = 
      let Ti7_22  : int = (x_8 + y_10) in
      (Ti7_22 + z_21)
   in g_20
in 
   let first_11  : (int) -> int = let Ti1_19  : int = 21 in
   (f_9 Ti1_19) in
   
   let second_12  : (int) -> int = let Ti2_18  : int = 88 in
   (f_9 Ti2_18) in
   
   let result_13  : int = let Ti4_14  : int = let Ti3_17  : int = 99 in
   (first_11 Ti3_17) in
   
   let Ti6_15  : int = let Ti5_16  : int = 44 in
   (second_12 Ti5_16) in
   (Ti4_14 + Ti6_15) in
   EXTERN(print_int result_13)

===================== simplify output ===============================

let x_8  : int = 17 in

let f_9  : (int) -> (int) -> inty_10 : int = 
   let g_20  : (int) -> intz_21 : int = 
      let Ti7_22  : int = (x_8 + y_10) in
      (Ti7_22 + z_21)
   in g_20
in 
   let Ti1_19  : int = 21 in
   
   let first_11  : (int) -> int = (f_9 Ti1_19) in
   
   let Ti2_18  : int = 88 in
   
   let second_12  : (int) -> int = (f_9 Ti2_18) in
   
   let Ti3_17  : int = 99 in
   
   let Ti4_14  : int = (first_11 Ti3_17) in
   
   let Ti5_16  : int = 44 in
   
   let Ti6_15  : int = (second_12 Ti5_16) in
   
   let result_13  : int = (Ti4_14 + Ti6_15) in
   EXTERN(print_int result_13)

===================== closure output ===============================
let LABEL(g_20) [x_8 : int, y_10 : int] z_21 : int = 
   let Ti7_22  : int = (x_8 + y_10) in
   (Ti7_22 + z_21)
in

let LABEL(f_9) [x_8 : int] y_10 : int = 
   let closure g_20  : (int) -> int = ( LABEL(g_20); [x_8, y_10] )
   in g_20
in

let x_8  : int = 17 in

let closure f_9  : (int) -> (int) -> int = ( LABEL(f_9); [x_8] )
in 
   let Ti1_19  : int = 21 in
   
   let first_11  : (int) -> int = APPLY_CLOSURE(f_9 Ti1_19) in
   
   let Ti2_18  : int = 88 in
   
   let second_12  : (int) -> int = APPLY_CLOSURE(f_9 Ti2_18) in
   
   let Ti3_17  : int = 99 in
   
   let Ti4_14  : int = APPLY_CLOSURE(first_11 Ti3_17) in
   
   let Ti5_16  : int = 44 in
   
   let Ti6_15  : int = APPLY_CLOSURE(second_12 Ti5_16) in
   
   let result_13  : int = (Ti4_14 + Ti6_15) in
   APPLY_DIRECT(LABEL(min_caml_print_int) result_13)

===================== virtual  output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(g_20) (arg=(z_21), farg=())

LET(y_10, ld(%o5, 8), 
   LET(x_8, ld(%o5, 4), 
      LET(Ti7_22, add(x_8, y_10), 
         ANSWER(add(Ti7_22, z_21)))))

LABEL(f_9) (arg=(y_10), farg=())

LET(x_8, ld(%o5, 4), 
   LET(g_20, mov(%i1), 
      LET(%i1, add(%i1, 16), 
         LET(l_25, set(LABEL(g_20)), 
            LET(Tu26, st(l_25, g_20, 0), 
               LET(Tu24, st(y_10, g_20, 8), 
                  LET(Tu23, st(x_8, g_20, 4), 
                     ANSWER(mov(g_20)))))))))
==== Expression =======

LET(x_8, set(17), 
   LET(f_9, mov(%i1), 
      LET(%i1, add(%i1, 8), 
         LET(l_28, set(LABEL(f_9)), 
            LET(Tu29, st(l_28, f_9, 0), 
               LET(Tu27, st(x_8, f_9, 4), 
                  LET(Ti1_19, set(21), 
                     LET(first_11, CallClosure(f_9, args=(Ti1_19), farg=()), 
                        LET(Ti2_18, set(88), 
                           LET(second_12, CallClosure(f_9, args=(Ti2_18), farg=()), 
                              LET(Ti3_17, set(99), 
                                 LET(Ti4_14, CallClosure(first_11, args=(Ti3_17), farg=()), 
                                    LET(Ti5_16, set(44), 
                                       LET(Ti6_15, CallClosure(second_12, args=(Ti5_16), farg=()), 
                                          LET(result_13, add(Ti4_14, Ti6_15), 
                                             ANSWER(CallDirect(LABEL(min_caml_print_int), args=(result_13), farg=())))))))))))))))))


=====================  simm13  output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(g_20) (arg=(z_21), farg=())

LET(y_10, ld(%o5, 8), 
   LET(x_8, ld(%o5, 4), 
      LET(Ti7_22, add(x_8, y_10), 
         ANSWER(add(Ti7_22, z_21)))))

LABEL(f_9) (arg=(y_10), farg=())

LET(x_8, ld(%o5, 4), 
   LET(g_20, mov(%i1), 
      LET(%i1, add(%i1, 16), 
         LET(l_25, set(LABEL(g_20)), 
            LET(Tu26, st(l_25, g_20, 0), 
               LET(Tu24, st(y_10, g_20, 8), 
                  LET(Tu23, st(x_8, g_20, 4), 
                     ANSWER(mov(g_20)))))))))
==== Expression =======

LET(x_8, set(17), 
   LET(f_9, mov(%i1), 
      LET(%i1, add(%i1, 8), 
         LET(l_28, set(LABEL(f_9)), 
            LET(Tu29, st(l_28, f_9, 0), 
               LET(Tu27, st(x_8, f_9, 4), 
                  LET(Ti1_19, set(21), 
                     LET(first_11, CallClosure(f_9, args=(Ti1_19), farg=()), 
                        LET(Ti2_18, set(88), 
                           LET(second_12, CallClosure(f_9, args=(Ti2_18), farg=()), 
                              LET(Ti3_17, set(99), 
                                 LET(Ti4_14, CallClosure(first_11, args=(Ti3_17), farg=()), 
                                    LET(Ti5_16, set(44), 
                                       LET(Ti6_15, CallClosure(second_12, args=(Ti5_16), farg=()), 
                                          LET(result_13, add(Ti4_14, Ti6_15), 
                                             ANSWER(CallDirect(LABEL(min_caml_print_int), args=(result_13), farg=())))))))))))))))))


===================== RegAlloc output ===============================
==== Data Segment =======
==== Function Declarations =======

LABEL(g_20) (arg=(%i2), farg=())

LET(%i3, ld(%o5, 8), 
   LET(%i4, ld(%o5, 4), 
      LET(%i3, add(%i4, %i3), 
         ANSWER(add(%i3, %i2)))))

LABEL(f_9) (arg=(%i2), farg=())

LET(%i3, ld(%o5, 4), 
   LET(%i4, mov(%i1), 
      LET(%i1, add(%i1, 16), 
         LET(%i5, set(LABEL(g_20)), 
            LET(%g0, st(%i5, %i4, 0), 
               LET(%g0, st(%i2, %i4, 8), 
                  LET(%g0, st(%i3, %i4, 4), 
                     ANSWER(mov(%i4)))))))))
==== Expression =======

LET(%i2, set(17), 
   LET(%o5, mov(%i1), 
      LET(%g0, save(%o5, f_9), 
         LET(%i1, add(%i1, 8), 
            LET(%i3, set(LABEL(f_9)), 
               LET(%g0, st(%i3, %o5, 0), 
                  LET(%g0, st(%i2, %o5, 4), 
                     LET(%i2, set(21), 
                        LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                           LET(%i2, mov(%i2), 
                              LET(%g0, save(%i2, first_11), 
                                 LET(%i2, set(88), 
                                    LET(%o5, restore(f_9), 
                                       LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                          LET(%i2, mov(%i2), 
                                             LET(%g0, save(%i2, second_12), 
                                                LET(%i2, set(99), 
                                                   LET(%o5, restore(first_11), 
                                                      LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                                         LET(%i2, mov(%i2), 
                                                            LET(%g0, save(%i2, Ti4_14), 
                                                               LET(%i2, set(44), 
                                                                  LET(%o5, restore(second_12), 
                                                                     LET(%i2, CallClosure(%o5, args=(%i2), farg=()), 
                                                                        LET(%i2, mov(%i2), 
                                                                           LET(%i3, restore(Ti4_14), 
                                                                              LET(%i2, add(%i3, %i2), 
                                                                                 ANSWER(CallDirect(LABEL(min_caml_print_int), args=(%i2), farg=())))))))))))))))))))))))))))))


===================== Emit output ===============================
.section	".rodata"
.align	8
.section	".text"
g_20:
	ld	[%o5 + 8], %i3
	ld	[%o5 + 4], %i4
	add	%i4, %i3, %i3
	add	%i3, %i2, %i2
	retl
	nop
f_9:
	ld	[%o5 + 4], %i3
	mov	%i1, %i4
	add	%i1, 16, %i1
	set	g_20, %i5
	st	%i5, [%i4 + 0]
	st	%i2, [%i4 + 8]
	st	%i3, [%i4 + 4]
	mov	%i4, %i2
	retl
	nop
.global	min_caml_start
min_caml_start:
	save	%sp, -112, %sp
	set	17, %i2
	mov	%i1, %o5
	st	%o5, [%i0 + 0]
	add	%i1, 8, %i1
	set	f_9, %i3
	st	%i3, [%o5 + 0]
	st	%i2, [%o5 + 4]
	set	21, %i2
	st	%o7, [%i0 + 4]
	ld	[%o5 + 0], %o4
	call	%o4
	add	%i0, 8, %i0	! delay slot
	sub	%i0, 8, %i0
	ld	[%i0 + 4], %o7
	st	%i2, [%i0 + 4]
	set	88, %i2
	ld	[%i0 + 0], %o5
	st	%o7, [%i0 + 12]
	ld	[%o5 + 0], %o4
	call	%o4
	add	%i0, 16, %i0	! delay slot
	sub	%i0, 16, %i0
	ld	[%i0 + 12], %o7
	st	%i2, [%i0 + 8]
	set	99, %i2
	ld	[%i0 + 4], %o5
	st	%o7, [%i0 + 12]
	ld	[%o5 + 0], %o4
	call	%o4
	add	%i0, 16, %i0	! delay slot
	sub	%i0, 16, %i0
	ld	[%i0 + 12], %o7
	st	%i2, [%i0 + 12]
	set	44, %i2
	ld	[%i0 + 8], %o5
	st	%o7, [%i0 + 20]
	ld	[%o5 + 0], %o4
	call	%o4
	add	%i0, 24, %i0	! delay slot
	sub	%i0, 24, %i0
	ld	[%i0 + 20], %o7
	ld	[%i0 + 12], %i3
	add	%i3, %i2, %i2
	st	%o7, [%i0 + 20]
	call	min_caml_print_int
	add	%i0, 24, %i0	! delay slot
	sub	%i0, 24, %i0
	ld	[%i0 + 20], %o7
	ret
	restore
